#COMPILE EXE
#DIM ALL
#INCLUDE "wIN32api.inc"

FUNCTION PBMAIN()
   LOCAL n, pid AS LONG
   LOCAL progFolder, dataFolder, myFolder, myLnk AS STRING
   progFolder = specialFolder(%CSIDL_PROGRAM_FILES)
   IF ISFOLDER(progFolder) THEN
      myFolder = progFolder + "\cgdSoftware\myPBEditor\"
      IF ISFOLDER(myFolder) THEN
         IF ISFILE(myFolder + "myPBEditor.exe") THEN
            n = MSGBOX("Uninstall myPBEditor now?", %MB_ICONQUESTION + %MB_YESNO, "Uninstall myPBEditor")
            IF n = %IDNO THEN EXIT FUNCTION
            IF ISFOLDER("C:\Temp") = 0 THEN MKDIR "C:\Temp" 'create temp folder if not existing
            'move the uninstall.exe file to a temp folder and run it from there
            FILECOPY myFolder + "uninstall.exe", "C:\Temp\uninstall.exe"
            CHDIR "C:\Temp"
            KILL myFolder + "myPBEditor.exe"
            pid = SHELL("C:\Temp\uninstall.exe"): EXIT FUNCTION
         END IF
         KILL myFolder + "*.*": RMDIR myFolder
         myFolder = progFolder + "\cgdSoftware\"
         IF LEN(DIR$(myFolder)) = 0 THEN RMDIR myFolder
      END IF
   END IF
   dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
   IF ISFOLDER(dataFolder) = 0 THEN dataFolder = "C:\My Documents"
   myFolder = dataFolder + "\cgdSoftware\myPBeditor\"
   IF ISFOLDER(myFolder) THEN
      KILL myFolder + "*.*": RMDIR myFolder
      myFolder = dataFolder + "\cgdSoftware\"
      IF LEN(DIR$(myFolder)) = 0 THEN RMDIR myFolder
      DIR$ CLOSE
   END IF
   KILL SpecialFolder(%CSIDL_DESKTOP) + "\myPBEditor.lnk"
   'KILL SpecialFolder(%CSIDL_DESKTOP) + "\my PBEditor.lnk"
   KILL SpecialFolder(%CSIDL_PROGRAMS) + "\myPBEditor.lnk"
END FUNCTION

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION
